#! /bin/sh
#
# Copyright (c) 1989-2013 Sophos Limited. All rights reserved.
# All rights reserved.
#

CIDREPDIR=`dirname $0`
CIDREPDIR=`cd $CIDREPDIR >/dev/null && pwd`
INSTALLORCOMMONDIR=$CIDREPDIR/..

PythonInterpreter=$INSTALLORCOMMONDIR/engine/python
[ -f $PythonInterpreter ] || PythonInterpreter=$INSTALLORCOMMONDIR/engine/_/python

ORIGINAL_PYTHONPATH="${ORIGINAL_PYTHONPATH-${PYTHONPATH}}"
ORIGINAL_LD_LIBRARY_PATH="${ORIGINAL_LD_LIBRARY_PATH-${LD_LIBRARY_PATH}}"
ORIGINAL_PYTHONHOME="${ORIGINAL_PYTHONHOME-${PYTHONHOME}}"
export ORIGINAL_PYTHONPATH
export ORIGINAL_LD_LIBRARY_PATH
export ORIGINAL_PYTHONHOME

APPPATH=$CIDREPDIR:$CIDREPDIR/cidrep.zip:$CIDREPDIR/installer.zip:$INSTALLORCOMMONDIR/engine/util.zip

#Settings for when SAV is installed, or minipkg
INSTDIR=$INSTALLORCOMMONDIR
PYTHONHOME=$INSTDIR
PythonStdModules=$INSTDIR/engine/python27.zip
if [ ! -f $PythonStdModules ]
then
    echo >&2 "Error: cannot find Python 2.7 distribution. Cannot run installer"
    exit 1
fi

PythonModsDir=$INSTDIR/engine/_
LD_LIBRARY_PATH=$INSTDIR/lib64:$INSTDIR/lib32:$INSTDIR/lib
[ -d /lib/nptl ] && LD_LIBRARY_PATH=$LD_LIBRARY_PATH:/lib/nptl
PYTHONHOME=$INSTDIR
PYTHONPATH=$PythonModsDir:$PythonStdModules:$APPPATH


export PYTHONPATH
export PYTHONHOME
export LD_LIBRARY_PATH

chmod 0755 $PythonInterpreter 2>/dev/null

$PythonInterpreter -c "import sys; sys.exit(0)" >/dev/null 2>&1 || {
    EXIT=$?

    MINIPKG=0
    case "$*" in
        *--minipkg*)
            MINIPKG=1
            ;;
    esac

    if [ $MINIPKG -eq 1 ] ; then
        UNAME="`uname -a | LC_ALL=C tr '[:upper:]' '[:lower:]'`"
        case "$UNAME" in
            *linux*x86_64*)
                file -L $PythonInterpreter | grep "ELF 32-bit" 1>/dev/null 2>&1 && {
                    echo >&2 "Error: Unable to run x86 installation package on this x86_64 system."
                    echo >&2 "       Please create the installation package on an x86_64 system or"
                    echo >&2 "       install x86 32-bit compatibility."
                    exit $EXIT
                }
                ;;
            *linux*)
                file -L $PythonInterpreter | grep "ELF 64-bit" 1>/dev/null 2>&1 && {
                    echo >&2 "Error: Unable to run x86_64 installation package on this x86 system."
                    echo >&2 "       Please create the installation package on an x86 system."
                    exit $EXIT
                }
                ;;
        esac
    fi

    echo >&2 "Error: Unable to start the installer."
    exit $EXIT
}

cd $INSTALLORCOMMONDIR
exec $PythonInterpreter -c "import savupdate.Updater,sys; sys.exit(savupdate.Updater.main(sys.argv))" "$CIDREPDIR" "$@"
